#include <windows.h>
#include <shlwapi.h>
#include <strsafe.h>
#include "main.h"

fptr_XWF_GetSize       XWF_GetSize;
fptr_XWF_Read          XWF_Read;
fptr_XWF_OutputMessage XWF_OutputMessage;

bool InitXWaysApi()
{
	HMODULE h = GetModuleHandle( NULL );
	if ( NULL == h )
	{
		return false;
	}

	XWF_GetSize = (fptr_XWF_GetSize) GetProcAddress( h, "XWF_GetSize" );
	XWF_Read = (fptr_XWF_Read) GetProcAddress( h, "XWF_Read" );
	XWF_OutputMessage = (fptr_XWF_OutputMessage) GetProcAddress( h, "XWF_OutputMessage" );

	if ( NULL == XWF_GetSize
		|| NULL == XWF_Read
		|| NULL == XWF_OutputMessage )
	{
		return false;
	}

	return true;
}


fptr_gsapi_new_instance     gsapi_new_instance;
fptr_gsapi_init_with_args   gsapi_init_with_args;
fptr_gsapi_exit             gsapi_exit;
fptr_gsapi_delete_instance  gsapi_delete_instance;

bool InitGhostScriptApi()
{
	//Determine the path of the X-Tension dll itself
	wchar_t dll_path[MAX_PATH];
	GetModuleFileName( (HINSTANCE) &__ImageBase, dll_path, MAX_PATH );
	//Substitute the name of the X-Tension dll in the path with "gsdll64.dll"
	if ( 0 == PathRemoveFileSpec( dll_path )
		|| FAILED( StringCchCat( dll_path, MAX_PATH, L"\\gsdll64.dll" ) ) )
	{
		//Something went wrong, try to load GhostScript from working directory
		StringCchCopy( dll_path, MAX_PATH, L"gsdll64.dll" );
	}
#ifdef DEBUG
	XWF_OutputMessage( L"\tLoading ", 2 );
	XWF_OutputMessage( dll_path, 3 );
#endif

	HMODULE h = LoadLibrary( dll_path );
	if ( NULL == h )
	{
		return false;
	}

	gsapi_new_instance = (fptr_gsapi_new_instance) GetProcAddress( h, "gsapi_new_instance" );
	gsapi_init_with_args = (fptr_gsapi_init_with_args) GetProcAddress( h, "gsapi_init_with_args" );
	gsapi_exit = (fptr_gsapi_exit) GetProcAddress( h, "gsapi_exit" );
	gsapi_delete_instance = (fptr_gsapi_delete_instance) GetProcAddress( h, "gsapi_delete_instance" );

	if ( NULL == gsapi_new_instance
		|| NULL == gsapi_init_with_args
		|| NULL == gsapi_exit
		|| NULL == gsapi_delete_instance )
	{
		return false;
	}

	return true;
}