#pragma once
#pragma comment(lib, "shlwapi.lib")

#include <windows.h>
#define EXPORT extern "C" __declspec(dllexport)

//Uncomment to enable debug messages in X-Ways Output Window
//#define DEBUG

extern "C" IMAGE_DOS_HEADER __ImageBase;

#pragma pack(push, 2)
struct LicenseInfo
{
	DWORD nSize;
	DWORD nLicFlags;
	DWORD nUsers;
	FILETIME nExpDate;
	BYTE nLicID[16];
};
#pragma pack(pop)

bool InitXWaysApi();
bool InitGhostScriptApi();

//X-Ways X-Tension API function pointers
typedef INT64( __stdcall * fptr_XWF_GetSize ) ( HANDLE hVolumeOrItem, LPVOID lpOptional );
typedef DWORD( __stdcall * fptr_XWF_Read ) ( HANDLE hVolumeOrItem, INT64 nOffset, LPVOID lpBuffer, DWORD nNumberOfBytesToRead );
typedef void( __stdcall * fptr_XWF_OutputMessage ) ( LPWSTR lpMessage, DWORD nFlags );
extern fptr_XWF_GetSize       XWF_GetSize;
extern fptr_XWF_Read          XWF_Read;
extern fptr_XWF_OutputMessage XWF_OutputMessage;

//GhostScript API function pointers
typedef int( __stdcall *fptr_gsapi_new_instance ) ( void **pinstance, void *caller_handle );
typedef int( __stdcall *fptr_gsapi_init_with_args ) ( void *instance, int argc, char **argv );
typedef int( __stdcall *fptr_gsapi_exit ) ( void *instance );
typedef void( __stdcall *fptr_gsapi_delete_instance ) ( void *instance );
extern fptr_gsapi_new_instance     gsapi_new_instance;
extern fptr_gsapi_init_with_args   gsapi_init_with_args;
extern fptr_gsapi_exit             gsapi_exit;
extern fptr_gsapi_delete_instance  gsapi_delete_instance;
